// ¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯  
/*                      _____________
 ✺*∵⁞⁞⁞⁞⁞░░▒▒▓▓███‖[  C O N S T  ]‖███▓▓▒▒░░⁞⁞⁞⁞※≡≒‗,∵ 
                        ¯¯¯¯¯¯¯¯¯¯¯¯¯                       */
  //#define DISABLE_CLICK
  
  #define LED         LED_BUILTIN
  #define setPin      digitalWrite
  #define getPin      digitalRead
  #define prnt        Serial.print
  #define prntln      Serial.println
  #define flsh        Serial.flush

  #define fString     __FlashStringHelper*
  #define LengthOf(x) (sizeof(x)/sizeof(x[0]))

  #define BUF_LEN 32
  
  enum : int { LO, HI, RETRIG};
  enum : int { ALL, MENU, TRIGGER, TILT };
  enum : int { NONE, SEMI, COMB, AUTO, FIRE_MODES};
  enum : int { SOLENOID, RUMBLE, BULBS, CLICK };
  enum : int {
    PIN_SOLEN   = 16,  // 12V 3A Power Solenoid
    PIN_RUMBL   = 17,  // 3V Rumble Motor inside gun
    PIN_BULBS   = 18,  // Dual 12v bulbs on top of gun
    PIN_CLICK   = 19,  // Mini-solenoid inside gun
    PIN_SDA     = 20,  // I2C SDA-pin on Pico (yellow)
    PIN_SCL     = 21,  // I2C SCL-pin on Pico (green)
    PIN_BOOT    = 22,  // BOOTSEL button on Pico
    PIN_TRIG    = 26,  // Gun Trigger
    PIN_TILT    = 27,  // Mercury Switch pin
    PIN_TEMP    = 28   // DS18S20 Temp. sensor pin
  };

  struct out {
    const char* name;
    int pin;
    bool enabled;
  } 
  OUTS[4] = {
    {"SOLENOID", PIN_SOLEN, 1},
    {"RUMBLE",   PIN_RUMBL, 1},
    {"BULBS",    PIN_BULBS, 1},
    {"CLICK",    PIN_CLICK, 1}
  };

  struct LIMIT { 
    int menu_toggle;
    int firemode_sw;
    int temp_limit;
    int temp_timeout;
    int solenoid[3]; // LO, HI, RETRIG
  };


// ¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯ 
/*                      ___________
 ✺*∵⁞⁞⁞⁞⁞░░▒▒▓▓███‖[  V A R S  ]‖███▓▓▒▒░░⁞⁞⁞⁞※≡≒‗,∵ 
                        ¯¯¯¯¯¯¯¯¯¯¯                      */              
  LIMIT Limits = {      //  'pressedFor' limits:
    1000,               //   - menu_toggle
    500,                //   - firemode_sw
    50,                 //   - temp_limit
    10000,              //   - temp_timeout
    {40, 100, 200}      //   - solenoid[LO|HI|RETRIG]
  };  

  char 
  buf [BUF_LEN];
  
  volatile bool
  menuMode   = true,
  testMode   = false,
  screenSeen = false;
  
  bool 
  loaded     = false,
  first_boot = true,
  trigReady  = true,
  overheat   = false,
  tilted     = false,
  reloaded   = true,
  reloadOffs = false;

  int 
  i,
  clip = -1,
  ammo = -1,
  temperature = 99,
  FireMode = SEMI;      // NONE, SEMI, COMB, AUTO

  unsigned long 
  T, tempCount;

  String
  cmd = "";

// ¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯
/*                    ____________________  
 ✺*∵⁞⁞⁞⁞⁞░▒▒▓▓███‖[   O B J E C T S   ]‖███▓▓▒▒░⁞⁞※≡≒‗,∵ 
                      ¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯                   */ 
                                          
  DFRobotIRPositionEx           // DFRobot SEN0158 Library
  DFRobotIRCam(Wire);           // IR Positioning Camera over I2C
  
  SamcoPositionSimplified       // Samco Lightgun Library (combined)
  SamcoPosition;                // Object for calculating position

  namespace MOUSE {             // Reserved namespace for the Mouse
    AbsMouse5_  Pointer(2);     // HID mouse instance via USB Serial
  }
  
  OneWire                       // OneWire Library for reading sensor
  ds(PIN_TEMP);                 // DS18B20 
  
  Toggle                        // Toggle Library
  BTN_Menu(PIN_BOOT),           // Toggle object for BOOTSEL output pin
  BTN_Trig(PIN_TRIG),           // Toggle object for Trigger input
  BTN_Tilt(PIN_TILT);           // Toggle object for 


// ¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯                
/*                _________________________________  
 ✺*∵⁞⁞⁞⁞⁞░▒▓███‖[ F U N C T I O N  D E C L A R E ]‖███▓▒░⁞⁞※≡≒‗,∵ 
                  ¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯                */
  void Menu();
  void GunInit();
  void switchFireMode();
  void readSerial();
  void Reload(bool state);
  void Blink(int pin,int n,int ms);
  void setOut(int index, bool state);
  void setPins(bool STATE);
  void checkTilt();
  bool checkTemp(bool force);
  int  checkMenuBtn();
  int  checkTrigger();
  int  readTemp();
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
  
  unsigned long elapsed(unsigned long& timer=T) { return (millis()-timer); }
  
  void update(unsigned long& timer=T){ timer = millis(); }

  void Blink(int pin=LED,int n=1,int ms=0){
    if (n>0) for(i=0;i<n;i++) setPin(pin,1),delay(ms),setPin(pin,0),delay(ms); else setPin(pin,!getPin(pin)),delay(ms); 
  }
  
  bool checkTemp(bool force=false) {
    if ((elapsed(tempCount) > Limits.temp_timeout) || force) { 
      temperature=readTemp(); tempCount=millis(); 
      overheat = (temperature >= Limits.temp_limit); 
    }    
    return (temperature < Limits.temp_limit); 
  }
  
// ¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯



  void GunInit() {
    testMode   = false; // fire and click without IR LEDs seen
    Limits.solenoid[RETRIG] = (Limits.solenoid[LO]+Limits.solenoid[HI]);
    while (temperature > 80) { temperature = readTemp(); delay(100); }
    tempCount = millis();
  }
  
  int checkMenuBtn() {
    int menuPressed = 0;
    if (BOOTSEL) setPin(PIN_BOOT,LOW); else setPin(PIN_BOOT,HIGH);
    if (BTN_Menu.onPress()) BTN_Menu.clearTimer(), menuPressed = 1; 
    
    if (BTN_Menu.pressedFor(Limits.menu_toggle)) Blink(LED,0,30), menuPressed = 2;
    else if (!menuMode) setPin(LED, screenSeen);  
    
    if (BTN_Menu.onRelease()) {
      if (BTN_Menu.getElapsedMs() > Limits.menu_toggle) menuMode = !menuMode;
      if (BTN_Menu.getElapsedMs() < Limits.firemode_sw) {
        if (menuMode)  switchFireMode(); 
      }
      BTN_Menu.clearTimer();       
    }
    BTN_Menu.poll();
    return menuPressed;       
  }

  int checkTrigger() { //(int &lo_lim=Limits.solenoid[LO], int &hi_lim=Limits.solenoid[HI]) {
    int trigState, triggerPressed = -1;
    BTN_Trig.poll();
    
    if (BTN_Trig.onRelease()) {   
      trigReady = false; triggerPressed = 0; //checkTemp(); 

      #ifndef DISABLE_CLICK
        MOUSE::Pointer.release(MOUSE_LEFT);   
      #endif 
          
      setPins(0); 
      setPin(PIN_CLICK, LOW); 
      BTN_Trig.clearTimer();    
    }   
    if (BTN_Trig.onPress()) { 
      if (trigReady) { BTN_Trig.clearTimer();
        if (screenSeen && (ammo != 0)) { // BTN_Trig.clearTimer();
          reloaded = false; triggerPressed = 1;

          #ifndef DISABLE_CLICK
            MOUSE::Pointer.press(MOUSE_LEFT);   
          #endif 
          
          if (FireMode != NONE){ 
            if (checkTemp()) setOut(SOLENOID, HIGH); //setPin(PIN_SOLEN, HIGH); 
            setOut(RUMBLE, HIGH); //setPin(PIN_RUMBL, HIGH); 
            setOut(BULBS,  HIGH); //setPin(PIN_BULBS, HIGH); 
          }
        }
        if (FireMode != NONE) setOut(CLICK, HIGH); //setPin(PIN_CLICK, HIGH);
      }
    }
    if (BTN_Trig.isReleased()) {
      trigReady = BTN_Trig.releasedFor(Limits.solenoid[LO]); 
      if (FireMode != NONE) {
         if (screenSeen) setOut(RUMBLE,!BTN_Trig.releasedFor(Limits.solenoid[LO])); //setPin(PIN_RUMBL,!BTN_Trig.releasedFor(Limits.solenoid[LO]));
         setOut(CLICK,!BTN_Trig.releasedFor(Limits.solenoid[HI])); //setPin(PIN_CLICK,!BTN_Trig.releasedFor(Limits.solenoid[HI]));
      }
    }
    if (FireMode != NONE) {
      if (BTN_Trig.isPressed()) {
        if (BTN_Trig.pressedFor(Limits.solenoid[LO])) {
          setOut(SOLENOID, LOW); //setPin(PIN_SOLEN, LOW); 
          setOut(BULBS,    LOW); //setPin(PIN_BULBS, LOW);
        }
        if (BTN_Trig.pressedFor(Limits.solenoid[HI])) {
          setOut(RUMBLE, LOW); //setPin(PIN_RUMBL, LOW); 
          setOut(CLICK,  LOW); //setPin(PIN_CLICK, LOW); 
        }
        if (FireMode > SEMI) {
          if (BTN_Trig.pressedFor(Limits.solenoid[RETRIG]) || (FireMode == AUTO)) {
            while (BTN_Trig.isPressed()) { BTN_Trig.poll();
              
              if (BTN_Trig.pressedFor(Limits.solenoid[RETRIG])) { // 40+((40*2)+(40/2))
                BTN_Trig.clearTimer(); setOut(CLICK, HIGH); //setPin(PIN_CLICK, HIGH);
                if (screenSeen && (ammo != 0)) {
                  if (checkTemp()) setOut(SOLENOID, HIGH); //setPin(PIN_SOLEN, HIGH); 
                  setOut(RUMBLE, HIGH); //setPin(PIN_RUMBL, HIGH); 
                  setOut(BULBS, HIGH); //setPin(PIN_BULBS, HIGH); 
                }
              } 
              else if (BTN_Trig.pressedFor(Limits.solenoid[LO])) { 
                  setPins(0); 
                  setOut(CLICK, LOW); //setPin(PIN_CLICK, LOW);
              }
              if ((ammo > 0) && (Serial.available() > 0)) readSerial();
            } 
          }          
        }  
      }      
    }
    return triggerPressed;
  }

  void checkTilt() {
    if (!menuMode) {
      BTN_Tilt.poll(); 
      if (BTN_Tilt.onPress() || BTN_Tilt.onRelease()) BTN_Tilt.clearTimer(); 

      if (!reloaded) {
        if (BTN_Tilt.isPressed()) { 
          //if (reloadOffs && !screenSeen) MOUSE::Pointer.press(MOUSE_LEFT);   
          if (BTN_Tilt.pressedFor(200) && (!tilted && !screenSeen)) Reload(1);
        } 
        else if (BTN_Tilt.isReleased() && tilted) {
          //if (reloadOffs) MOUSE::Pointer.release(MOUSE_LEFT);   
          if (BTN_Tilt.releasedFor(200)) Reload(0);       
        } 
                 
      }
    }
  }
  
  void Reload(bool state) {
    if (state == 1 && !tilted) {
      #ifndef DISABLE_CLICK
      //if (reloadOffs) MOUSE::Pointer.press(MOUSE_LEFT);   
      MOUSE::Pointer.press(MOUSE_MIDDLE);   
      #endif 
      
      Blink(PIN_CLICK,3,20); Blink(PIN_RUMBL,0,20); Blink(PIN_RUMBL,0); Blink(PIN_CLICK,2,120);
      tilted = true; 
    } else {
      #ifndef DISABLE_CLICK
        //if (reloadOffs) MOUSE::Pointer.release(MOUSE_LEFT);   
        MOUSE::Pointer.release(MOUSE_MIDDLE);   
      #endif    
      
      Blink(PIN_RUMBL,1,20);Blink(PIN_CLICK,2,40);      
      tilted = false; reloaded = true;   
    }
  }

  int readTemp() {
    byte data[12],addr[8];
    if (!ds.search(addr)){ ds.reset_search(); return -1000; }
    if (OneWire::crc8(addr,7)!=addr[7])       return -1000;
    if (addr[0]!=0x10 && addr[0]!=0x28)       return -1000;
    
    ds.reset(); ds.select(addr); ds.write(0x44,1);
    ds.reset(); ds.select(addr); ds.write(0xBE); 
    for (int i=0;i<9;i++) data[i]=ds.read(); ds.reset_search();
    
    byte MSB = data[1], LSB = data[0]; 
    float tempRead = ((MSB << 8) | LSB); 
    int TemperatureSum = (tempRead / 16);
    
    #if DEBUG
    prnt(F("Temp: ")),prnt(TemperatureSum);prnt(F(" (")),prnt(tempRead / 16),prntln(F(")")),flsh();
    #endif
    
    return TemperatureSum;
  }

  void switchFireMode() {
    FireMode++; FireMode %= FIRE_MODES;
    #if DEBUG
    prnt("FireMode: ");prnt(FireMode);
    switch(FireMode) {
      case 0: prntln(F(" NONE")); break;
      case 1: prntln(F(" SEMI")); break;
      case 2: prntln(F(" COMB")); break;
      case 3: prntln(F(" AUTO")); break;
      default: break;
    }
    flsh();
    #endif
  }

  void setPins(bool STATE) {
    setPin(PIN_SOLEN, STATE);
    setPin(PIN_RUMBL, STATE);
    setPin(PIN_BULBS, STATE);
  }

  void setOut(int index, bool state) {
    if (OUTS[index].enabled) 
      setPin(OUTS[index].pin, state);
  }

  bool fired = false;
  bool solenOn = true;
  
  void triggerTest() {
    int trigState, triggerPressed = -1;
    BTN_Trig.poll();
    
    if (BTN_Trig.onRelease()) { 
      if (fired) BTN_Trig.clearTimer(); 
      setPin(PIN_CLICK, LOW); setPin(PIN_RUMBL, LOW); setPin(PIN_SOLEN, LOW);
    }   
    if (BTN_Trig.onPress()) { fired = false; 
      if (BTN_Trig.getElapsedMs() > 60) {
        if (solenOn) setPin(PIN_SOLEN, HIGH); 
        setPin(PIN_CLICK, HIGH); setPin(PIN_BULBS, HIGH); //setPin(PIN_RUMBL, HIGH); 
        BTN_Trig.clearTimer(); fired = true; 
      }
    }
    if (BTN_Trig.isPressed()) {
      //if (BTN_Trig.pressedFor(20)) setPin(PIN_RUMBL, LOW); 
      if (BTN_Trig.pressedFor(140)) {
        BTN_Trig.clearTimer();
        while (BTN_Trig.isPressed()) { BTN_Trig.poll();
          if (ammo != 0) {
            if (solenOn) setPin(PIN_SOLEN, !BTN_Trig.pressedFor(50));
            if (BTN_Trig.pressedFor(140)) { BTN_Trig.clearTimer();
              setPin(PIN_CLICK, LOW); setPin(PIN_RUMBL, LOW); setPin(PIN_BULBS, LOW); setPin(PIN_SOLEN, LOW);
            } else {
              if (!BTN_Trig.pressedFor(70)) {
                setPin(PIN_RUMBL, !BTN_Trig.pressedFor(5));
                setPin(PIN_BULBS, !BTN_Trig.pressedFor(5));
                setPin(PIN_CLICK, !BTN_Trig.pressedFor(20));
              } else {
                setPin(PIN_RUMBL, !BTN_Trig.pressedFor(75));
                //setPin(PIN_BULBS, !BTN_Trig.pressedFor(72));
                setPin(PIN_CLICK, !BTN_Trig.pressedFor(90));              
              }
            }
          }
          setPin(LED,screenSeen);
          if (Serial.available() > 0) readSerial();
        } 
        setPin(PIN_CLICK, LOW); setPin(PIN_RUMBL, LOW); setPin(PIN_BULBS, LOW); setPin(PIN_SOLEN, LOW);
      } else {
        if (BTN_Trig.pressedFor(50)) {
          setPin(PIN_CLICK, LOW); setPin(PIN_RUMBL, LOW); setPin(PIN_BULBS, LOW); setPin(PIN_SOLEN, LOW);
        } else {
          setPin(PIN_BULBS, !BTN_Trig.pressedFor(20));
          setPin(PIN_RUMBL, BTN_Trig.pressedFor(30));
        }        
      }

    }
    if (BTN_Trig.isReleased()) {
      //trigReady = BTN_Trig.releasedFor(30);
      if (fired) {
        if (BTN_Trig.releasedFor(20)) setPin(PIN_RUMBL, !BTN_Trig.releasedFor(30));
        setPin(PIN_CLICK, !BTN_Trig.releasedFor(100));
        //setPin(PIN_RUMBL, !BTN_Trig.releasedFor(10));
      }
      if (BTN_Trig.releasedFor(1000)) {
        trigReady = true;
        fired = false; 
      }
    }
  }

  
  // ¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯
  namespace DEBUGGER {
    void Debug();
    void Setup();
    
    // - - - - - - - - - - - - - - - 
    
    const unsigned int txt_sz = 3, str_sz = 16;
    struct TXT{ char str[str_sz]; } cmds[txt_sz]={ "","",""};
    enum : int{ CMD, OPT, ARG };
    char *str_cmd, *str_opt, *str_arg, *token;
    int n = 0, index = 0, limits[3]; 
    
    // - - - - - - - - - - - - - - - 
    
    void char2Lim(char* tkn) {
      prnt("limits["),prnt(index),prnt("] : "),prntln(tkn);flsh();
      limits[index++] = (int)atoi(tkn);
    } 
    // - - - - - - - - - - - - - - - 
        
    void Debug() { index = 0; n = 0;
      for (i=0; i<txt_sz; i++) strncpy(cmds[i].str,"",str_sz); 
      while (Serial.available()) { 
        char c = Serial.read(); 
        if ( !isSpace(c) ) cmds[index].str[n++] = c; 
        else cmds[index].str[n++] = '\0', n=0, index++;
        if (c == '\n' || index >= txt_sz) Serial.read(); 
      } 
      if (index < (txt_sz-1)) 
        for (i=(index+1); i<txt_sz; i++) strncpy(cmds[i].str,"",str_sz); prntln();
        
      for (i=0; i<txt_sz; i++) prnt("cmds["),prnt(i),prnt("] "),prntln(cmds[i].str); 
      index = 0;
      // - - - - - - - - - - - - - - - 

      if (strlen(cmds[ARG].str) == 0){ 
        prntln(F("NOT ENOUGH ARGS!"));flsh(); return; } 
        
      else { 
        str_arg = strdup(cmds[ARG].str); str_cmd = strdup(cmds[CMD].str); str_opt = strdup(cmds[OPT].str);  
        
        if (str_cmd == "TEST") {
          if (str_opt == "SOLENOID") { 
            while ((token = strsep(&str_arg,","))) char2Lim(token);
            limits[RETRIG] = (limits[LO]+limits[HI]); 
            prnt(F("limits[RETRIG]: ")),prntln(limits[RETRIG]);flsh();
          } 
        }
      }
    } 

    void TestGun() {
      String msg; int x,y; int menuHeld = 0;

      while (1) {
        while (Serial.available() == 0){ 
          if (BOOTSEL) setPin(PIN_BOOT,LOW); else setPin(PIN_BOOT,HIGH);
          BTN_Menu.poll(); BTN_Tilt.poll();
          
          if (BTN_Menu.onPress()) { BTN_Menu.clearTimer();
            MOUSE::Pointer.press(MOUSE_RIGHT),delay(100),MOUSE::Pointer.release(MOUSE_RIGHT); 
          }
          if (BTN_Menu.onRelease()) BTN_Menu.clearTimer();

          /*if (BTN_Menu.pressedFor(500)) { x=0; y=0;
            while (((x<MouseMaxX)&&(y<MouseMaxY))) MOUSE::Pointer.move(x++,y++),delay(1);
            MOUSE::Pointer.move(0,0); BTN_Menu.clearTimer();
          }*/
          
          BTN_Trig.poll(); 
          
          if (BTN_Trig.onPress()) { BTN_Trig.clearTimer();
            MOUSE::Pointer.press(MOUSE_LEFT),delay(100),MOUSE::Pointer.release(MOUSE_LEFT); 
          }    
          if (BTN_Trig.onRelease()) BTN_Trig.clearTimer();    
        }
        if (Serial.available()>0) { setPin(LED,HIGH); 
          msg = Serial.readStringUntil('\n');
          Serial.print("GUN: "); Serial.println(msg); Serial.flush();
        }
      }
    }

  } // <-- END OF NAMESPACE

  void readSerial() {
    String msg  = Serial.readStringUntil('\n');
    int args = msg.indexOf(' ');


    if (msg.length() > 1) {
      Serial.print("GUN "); Serial.println(msg);
  
      if (args < 0) { // single arg
        if (msg == "LOADED") {
          Blink(PIN_RUMBL,1,20), Blink(PIN_CLICK,2,40);
          loaded = true;
        }
        if (msg == "UNLOAD") {
          Blink(PIN_RUMBL,1,20);
          loaded = false; 
          reloadOffs = false; 
          clip = -1; 
          ammo = -1;
          menuMode = true;
        }
      } else {
        //msg.substring((args+1), msg.length()).toCharArray( buf, msg.substring((args+1),msg.length()).length()+1 );
        if (msg.substring(0,args) == "OUTS") {
          int pos = 0;
          msg = msg.substring((args+1),msg.length());
          
          while (msg.length() > 0) {
            args = msg.indexOf(' ');
            if (args > -1) {
              if (isDigit(msg[0])) 
                OUTS[pos].enabled = (bool)msg.substring(0,1).toInt();
              pos++;
              msg = msg.substring((args+1),msg.length());
            }
            else {
              if (msg.length() > 0) {
                if (isDigit(msg[0])) 
                  OUTS[pos].enabled = (bool)msg.substring(0,1).toInt();
                pos++;
              }
              break;
            }
          }
          if (DEBUG) {
            for (int i = 0; i < LengthOf(OUTS); i++) 
              Serial.print(OUTS[i].name), Serial.print(" "),
              Serial.print(OUTS[i].pin), Serial.print(" "),
              Serial.print(OUTS[i].enabled), Serial.println();            
          }
        }  
        else if (msg.substring(0,args) == "FIREMODE") {
          if (msg.substring((args+1),msg.length()) == "AUTO") FireMode = 3;
          if (msg.substring((args+1),msg.length()) == "SEMI") FireMode = 1;
          if (msg.substring((args+1),msg.length()) == "NONE") FireMode = 0;
        }
        else if (msg.substring(0,args) == "AMMO") {
          ammo = msg.substring((args+1),msg.length()).toInt();        
          if ((ammo == 0) && (clip > 0)) ammo = 1;
        }
        else if (msg.substring(0,args) == "CLIP") {
          clip = msg.substring((args+1),msg.length()).toInt();
          //if (clip > -1) ammo = (ammo + clip);
        }
        else if (msg.substring(0,args) == "RELOAD") reloadOffs = true;
      }
      Serial.flush();
    }

  }

  
