#ifndef _SamcoPositionSimplified_h_
  #define _SamcoPositionSimplified_h_
  
  #include <stdint.h>
  
  constexpr int CamResX = 1024;
  constexpr int CamResY = 768;
  constexpr int CamMaxX = CamResX - 1;
  constexpr int CamMaxY = CamResY - 1; 
  
  constexpr int CamToMouseShift = 2; 
  constexpr int CamToMouseMult = 1 << CamToMouseShift; 
  
  constexpr int MouseResX = CamResX * CamToMouseMult;
  constexpr int MouseResY = CamResY * CamToMouseMult;
  constexpr int MouseMaxX = MouseResX - 1;
  constexpr int MouseMaxY = MouseResY - 1;
  
  
  class SamcoPositionSimplified {
  
    int positionXX[4];
    int positionYY[4];
  
    int positionX[4];
    int positionY[4];
  
    unsigned int see[4];
  
    int medianY = MouseMaxY / 2;
    int medianX = MouseMaxX / 2;
  
    int FinalX[4] = {400 * CamToMouseMult, 623 * CamToMouseMult, 400 * CamToMouseMult, 623 * CamToMouseMult};
    int FinalY[4] = {200 * CamToMouseMult, 200 * CamToMouseMult, 568 * CamToMouseMult, 568 * CamToMouseMult};
  
    float xDistTop;
    float xDistBottom;
    float yDistLeft;
    float yDistRight;
  
    float angleTop;
    float angleBottom;
    float angleLeft;
    float angleRight;
  
    float angle;
    float height;
  
    float angleOffset[4];
  
    int xx;
    int yy;
  
    unsigned int start = 0;
  
    unsigned int seenFlags = 0;
  
  public:
    void begin(const int* px, const int* py, unsigned int seen, int cx, int cy);
    
    int testX(int index) const { return FinalX[index]; }
    int testY(int index) const { return FinalY[index]; }
    unsigned int testSee(int index) const { return see[index]; }
    int testMedianX() const { return medianX; }
    int testMedianY() const { return medianY; }
    
    int x() const { return xx; } 
    int y() const { return yy; } 
    float h() const { return height; } 
    unsigned int seen() const { return seenFlags; }
  };

#endif
