#include "src/FutabaVFD8/FutabaVFD8.h"

futabavfd8::VFD vfd(8,7);

// static void vfd_set_brightness(unsigned char level);

byte count = 0;
String testString = "0123456789ABCDEF";
String testString2 = "P L A Y E R  R E A D Y";
//String output;

void setup()
{
    Serial.begin(9600);
    Serial.setTimeout(10);
    vfd.Init();   
}

void loop()
{
    vfd.SetBrightness(255);

    //VFDemo(testString2);
    
    serialRead();
}

void serialRead() {
    int busy = 1;
    String output = "";
    String cmdString;
    String msg;

    while (busy == 1) {
        if (Serial.available()) {
            //delay(100);
            char c = Serial.read(); //gets one byte from serial buffer

            if (c != ';') {
                output += c;
            } else {
                busy = 0;
            }
        }
    }
    Serial.println(output);

    int strLength = output.length();
    cmdString = output.substring(0, 2);
    int cmd = cmdString.toInt();
    msg = output.substring(2, strLength);

    msgCommander(cmd, msg);  
}

void msgCommander(int cmd, String input) {
    if (cmd == 0)  {
        vfd.clear();
        FadeInWrite(0, input, 50, 1000);
        delay(4000);
        FadeOutClear(100, 500); // Speed factor, post delay
    }
    if (cmd == 1) {
        vfd.clear();
        ScrollWriteString(input, 80);
    }
    if (cmd == 2) {
        TypeWriteString(0, input, 80, true, true); //print overflow, manual TypeClear
        delay(1000);
        TypeClear(40, false); // interval, reverse
        delay(1000);
    }
    if (cmd == 3) {
        TypeWriteString(0, input, 80, false, false); //no overflow, manual TypeClear
        delay(1000);
        TypeClear(40, true); // interval, reverse
        delay(1000);
    }
    if (cmd == 4) {
        TypeWriteString(0, input, 80, false, false); //no overflow, FadeOutClear
        delay(500);
        FadeOutClear(200, 500); // Speed factor, post delay
        delay(1000);
    }
    if (cmd == 5) {
        FlashString(input, 50, 3, 200); // BlinkInterval, iterations, postDelay
    }
    if (cmd == 6) {
        BlinkString(input, 60, 20, 200); // BlinkInterval, iterations, postDelay
    }
    if (cmd == 7) {
        AccelerateBlink(input, 4, 50, 2); // SpeedInterval, Floor, Ceiling, boolean fadeout
    }
}



// TYPEWRITESTRING
void TypeWriteString(int pos, String str, unsigned long interval, boolean scroll, boolean typeClearAfter) {
    TypeWriteString(pos, str, interval, scroll);
    if (typeClearAfter) TypeClear(interval);
}

void TypeWriteString(int pos, String str, unsigned long interval, boolean scroll)
{
    vfd.clear();

    byte str_len = str.length() + 1;
    byte buffer[str_len];
    str.toCharArray(buffer, str_len);

    int i = 0;
    for (; i < 16 && i < (str_len - 1); i++) {
        vfd.Write(pos + i, buffer[i]);
        delay(interval);
    }
    if (scroll && str_len > 16) {
        i -= 16;
        for ( ; i < (str_len - 16); ++i) {
            vfd.Write(0, 16, (const byte*)buffer+i);
            delay(interval);
        }
    }
}
//////////////////////////////////////////////////////

// SCROLLWRITESTRING
void ScrollWriteString(String str, unsigned long interval) {
    String msg = "";
    String spaces = "                ";
    msg += spaces;
    msg += str;
    msg += spaces;
    
    byte str_len = msg.length() + 1;
    byte buffer[str_len];
    msg.toCharArray(buffer, str_len);

    for (int i = 0; i < (str_len - 16); i++) {
        // send command
        // vfd.Write(0, 16, (const byte*)chars+i);
        vfd.Write(0, 16, (const byte*)buffer+i);
        // wait for next iteration
        delay(interval);
    }

    delay(1000);
}
//////////////////////////////////////////////////////

// HELPERS for 'FadeInWrite'
void FadeInWrite(byte pos, String str) {
    FadeInWrite(pos, str, 100, 500, vfd.GetBrightness());
}
void FadeInWrite(byte pos, String str, unsigned long speedFactor) {
    FadeInWrite(pos, str, speedFactor, 500, vfd.GetBrightness());
}
void FadeInWrite(byte pos, String str, unsigned long speedFactor, unsigned long preDelay) {
    FadeInWrite(pos, str, speedFactor, preDelay, vfd.GetBrightness());
}
void FadeInWrite(byte pos, String str, unsigned long speedFactor, unsigned long preDelay, byte brightness) {
    vfd.clear();
    vfd.SetBrightness(0);
    vfd.WriteString(pos, str);
    delay(preDelay);

    for (int count = 0; count <= brightness; count++) {
        vfd.SetBrightness(count);
        delay( (1.0*brightness/count)*speedFactor/100 );
    }
}
//////////////////////////////////////////////////////

// FLASH STRING (FADE/IN OUT N TIMES))
void FlashString(String str, unsigned int blinkInterval, unsigned int iterations, unsigned int postDelay) {
    int fadeSpeed = 30;
    if (blinkInterval > 60) fadeSpeed = (blinkInterval / 2);

    for (int i = 0; i < iterations; i++) {
        vfd.clear();
        FadeInWrite(0, str, fadeSpeed, 0, vfd.GetBrightness());
        delay(blinkInterval);
        FadeOutClear(fadeSpeed, postDelay); // Speed factor, post delay
    }
}
//////////////////////////////////////////////////////

// BLINK STRING
void BlinkString(String str, unsigned int blinkInterval, unsigned int iterations, byte brightness) {
    int blinkSpeed;
    blinkSpeed = (blinkInterval / 2);
    
    vfd.clear();
    vfd.SetBrightness(0);

    for (int i = 0; i < iterations; i++) {
        vfd.SetBrightness(brightness);
        vfd.WriteString(0, str);
        delay(blinkSpeed);
        vfd.clear();
        vfd.SetBrightness(0);
        delay(blinkSpeed);


    }
}
//////////////////////////////////////////////////////


// ACCELERATING BLINK STRING
void AccelerateBlink(String str, unsigned int accelSpeed, unsigned int floor, unsigned int ceiling) {

    unsigned int brightness = 200;
    vfd.clear();
    vfd.SetBrightness(0);
    
    for (int interval = floor; interval > ceiling; interval--) {
        //BlinkString(str, interval, accelSpeed, 255);
        interval = map(interval, floor, ceiling, (floor * (accelSpeed*0,01)),(ceiling * (accelSpeed*0,01)));

        //for (int i = 0; i < accelSpeed; i++) {
        
            if (interval < ((floor * 0,01) * 20 ) && interval > ((floor * 0,01) * 18 )) {
                brightness = 150;
                vfd.SetBrightness(brightness);
            } else if (interval < ((floor * 0,01) * 18 ) && interval > ((floor * 0,01) * 15 )) {
                brightness = 100;
                vfd.SetBrightness(brightness);
            } else if (interval < ((floor * 0,01) * 15 ) && interval > ((floor * 0,01) * 12 )) {
                brightness = 80;
                vfd.SetBrightness(brightness);
            } else if (interval < ((floor * 0,01) * 12 ) && interval > ((floor * 0,01) * 10 )) {
                brightness = 50;
                vfd.SetBrightness(brightness);
            } else if (interval < ((floor * 0,01) * 10 ) && interval > ((floor * 0,01) * 8 )) {
                brightness = 30;
                vfd.SetBrightness(brightness);
            } else if (interval < ((floor * 0,01) * 8 ) && interval > ((floor * 0,01) * 5 )) {
                brightness = 20;
                vfd.SetBrightness(brightness);
            } else if (interval < ((floor * 0,01) * 5 ) && interval > ((floor * 0,01) * 1 )) {
                brightness = 10;
                vfd.SetBrightness(brightness);
            } else if (interval < ((floor * 0,01) * 1) && interval > (floor * 0,005)) {
                brightness = 5;
                vfd.SetBrightness(brightness);
            }
        
            vfd.SetBrightness(brightness);
            vfd.WriteString(0, str);
            delay(interval);
            vfd.clear();
            vfd.SetBrightness(0);
            delay(interval);
        //}
    }
}
//////////////////////////////////////////////////////


// TYPECLEAR
void TypeClear(unsigned long interval, boolean reverse) {
    for (int i = 0; i < 16; i++) {
        byte pos = i;
        if (reverse) pos = 15 - i;
        // Shorter but not alwayas as readable
        // byte pos = (reverse ? 15 - i : i);

        vfd.Write(pos, ' ');
        delay(interval);
    }
}

void TypeClear(unsigned long interval) {
    TypeClear(interval, false);
}
//////////////////////////////////////////////////////

// FADEOUTCLEAR
void FadeOutClear(unsigned long speedFactor) {
    FadeOutClear(speedFactor, 200);
}
void FadeOutClear(unsigned long speedFactor, unsigned long postDelay) {
    byte prev_bright = vfd.GetBrightness();
    for (int count = prev_bright; count >= 0 ; count--) {
        vfd.SetBrightness(count);
        delay( (1.0*prev_bright/count)*speedFactor/100 );
    }
    vfd.clear();
    delay(postDelay);
    vfd.SetBrightness(prev_bright);
}
//////////////////////////////////////////////////////


// DEMO #2
void VFDemo(String input) {
    String string5 = "     1 9 8 6     ";
    FlashString(string5, 50, 3, 200); // BlinkInterval, iterations, postDelay
    
    String string0 = "   A R C A D E   ";
    vfd.clear();
    FadeInWrite(0, string0, 50, 1000);
    delay(4000);
    FadeOutClear(100, 500); // Speed factor, post delay

    String string1 = "ALL YOUR 50p ARE BELONG TO US!";
    vfd.clear();
    ScrollWriteString(string1, 80);
    
    String string2 = "V . F . D . - VACUUM FLOURESCENT DISPLAY";
    TypeWriteString(0, string2, 80, true, true); //print overflow, manual TypeClear
    delay(1000);
    TypeClear(40, false); // interval, reverse
    delay(1000);

    String string3 = "CODED BY DIMSOS";
    TypeWriteString(0, string3, 80, false, false); //no overflow, manual TypeClear
    delay(1000);
    TypeClear(40, true); // interval, reverse
    delay(1000);

    String string4 = "AND  DOGENIGT";
    TypeWriteString(0, string4, 80, false, false); //no overflow, FadeOutClear
    delay(500);
    FadeOutClear(200, 500); // Speed factor, post delay
    delay(1000);


    String string6 = "G A M E  O V E R";
    BlinkString(string6, 60, 20, 200); // BlinkInterval, iterations, postDelay
    String string7 = "ARE YOU READY?";
    AccelerateBlink(string7, 4, 50, 2); // SpeedInterval, Floor, Ceiling, boolean fadeout


}

// DEMO #1
void Demo() {
    // FADEINWRITE / FADEOUTCLEAR
    // Print string, fade in and fade out
    vfd.clear();
    FadeInWrite(0, testString, 50, 1000);
    delay(1000);
    FadeOutClear(100, 500); // Speed factor, post delay
    //////////////////////////////////////////////////////


    // TYPEWRITESTRING VARIATIONS
    // Type string one char at a time, erase on char at a time (no overflow)
    TypeWriteString(0, testString, 80, false, true); // print overflow, TypeClear
    //delay(500);
    //FadeOutClear(200, 500); // Speed factor, post delay
    delay(1000);

    // Type string one char at a time, fade out (no overflow)
    TypeWriteString(0, testString, 80, false, false); // print overflow, FadeOutClear
    delay(500);
    FadeOutClear(200, 500); // Speed factor, post delay
    delay(1000);

    // Type string one char at a time, erase on char at a time (no overflow)
    TypeWriteString(0, testString, 80, true, true); // print overflow, TypeClear, scroll
    delay(500);
    //TypeClear(250, true);
    vfd.clear();
    delay(1000);
    //////////////////////////////////////////////////////

    // Write string, scroll one char at a time from right to left
    ScrollWriteString(testString, 80); // interval for shifting left
    delay(500);
    vfd.clear();
    delay(1000);
    //////////////////////////////////////////////////////
}


// Print string and replace character
// vfd.WriteString( 0, testString );
// delay(1500);
// vfd.Write(12, 'X');

// while (false) {
//     byte max_bright = 127;
//     count++;
//     vfd.SetBrightness( count );

//     if (0 == count) delay( 250 );
//     delay( (1.0*max_bright/count)/5 ) ;

//     if (max_bright/2 == count) {
//         vfd.Write(9, 'P');
//     }
//     if (max_bright == count) {
//         vfd.Write(9, 'B');
//     }

// }
///////////////////////////////////////////////////////
