#include "Wire.h"
#include "FILTER.h"

#define DEBUG       0

#define setPin      digitalWrite
#define getPin      digitalRead
#define prnt        Serial.print
#define prntln      Serial.println

#define AXIS0       9
#define AXIS1       10
#define LED         13

#define THRESH      48
#define serial_ms   200
#define ADDR        0x68
#define BAUD        115200

// ------------------------------

unsigned long update = 0;
unsigned char err = 0x01;
unsigned int  AOUT0, AOUT1;

// ------------------------------

void setup() {
  Wire.begin();  
  Serial.begin(BAUD);
  Serial.println("Begin!");

  pinMode(AXIS0, OUTPUT);
  pinMode(AXIS1, OUTPUT);
  pinMode(LED,   OUTPUT);  
  setPin(LED,LOW);
  
  while (err) {
    Wire.beginTransmission(ADDR);     // defaults for gyro and accel sensitivity are 250 dps and +/- 2 g
    Wire.write(0x6B);                 // PWR_MGMT_1 register
    Wire.write(0);                    // set to zero (wakes up the MPU-6050)
    err = Wire.endTransmission(true);   
  }

  for (int i=0; i<20; i++) setPin(LED,!getPin(LED)),delay(30);
  prntln("Wire ready!");
  update = millis();
}

// ------------------------------

void loop() {
  int THRESH_LO = (THRESH-(THRESH*2));
  poll(); // sets yaw, pitch, roll.

  // AXIS0 AnalogWrite
  if ((roll>(THRESH_LO*1.0))&&(roll<(THRESH*1.0))) { 
    AOUT0 = map(roll,(THRESH_LO*1.0),(THRESH*1.0),0,255);
    setPin(LED, HIGH);
  } else { 
    if (roll<(THRESH_LO*1.0)) AOUT0 = 0;
    if (roll>(THRESH*1.0))    AOUT0 = 255;
    setPin(LED, LOW);
  }
  analogWrite(AXIS0, AOUT0);  
  
  // AXIS1 AnalogWrite  
  if (AOUT0 > (127+THRESH)){  AOUT1 = 255; } 
  else { 
    if (AOUT0 > (127-THRESH)) AOUT1 = 127; 
    else AOUT1 = 0;
  }
  analogWrite(AXIS1, AOUT1); 

  if (DEBUG) {
    if ((millis()-update) > 100) {
      prnt("roll: "), prnt(roll), prnt(", AXIS0: "), prnt(AOUT0), prnt(", AXIS1: ");prntln(AOUT1);
      update = millis();
    }     
  }
}
